import { coord, t, util } from '../../common';
export declare type CellChangeField = keyof t.IGridCellProps | 'VALUE' | 'PROPS';
export declare class Cell<P extends t.IGridCellProps = t.IGridCellProps> implements t.IGridCell<P> {
    static isEmpty: typeof util.cell.value.isEmptyCell;
    static isEmptyProps: typeof util.cell.value.isEmptyCellProps;
    static isEmptyValue: typeof util.cell.value.isEmptyCellValue;
    static diff: typeof util.cell.value.cellDiff;
    static props: typeof util.toGridCellProps;
    static create(args: {
        table: Handsontable;
        ns: string;
        row: number;
        column: number;
    }): Cell<Partial<t.IGridCellPropsAll>>;
    static createFromKey(args: {
        table: Handsontable;
        ns: string;
        cellKey: string;
    }): Cell<Partial<t.IGridCellPropsAll>>;
    static toKey(args: {
        row: number;
        column: number;
    }): string;
    static fromKey(cellKey: string): coord.ICoordPosition;
    static toPosition(ref: t.GridCellRef): t.ICoordPosition;
    static toRangePositions(args: {
        range: string;
        totalColumns: number;
        totalRows: number;
    }): {
        start: coord.ICoord;
        end: coord.ICoord;
    };
    static changeEvent(args: {
        cell: t.ICoord;
        from?: t.IGridCellData;
        to?: t.IGridCellData;
    }): t.IGridCellChange;
    private constructor();
    get isDisposed(): boolean;
    readonly ns: string;
    readonly row: number;
    readonly column: number;
    private readonly _;
    get key(): string;
    private get td();
    get size(): {
        width: number;
        height: number;
    };
    get width(): number;
    get height(): number;
    get data(): t.ICellData<P>;
    get siblings(): {
        readonly left: Cell<Partial<t.IGridCellPropsAll>> | undefined;
        readonly right: Cell<Partial<t.IGridCellPropsAll>> | undefined;
        readonly top: Cell<Partial<t.IGridCellPropsAll>> | undefined;
        readonly bottom: Cell<Partial<t.IGridCellPropsAll>> | undefined;
    };
    get rowspan(): number;
    get colspan(): number;
    toString(): void;
}
